/*
 * linux/include/asm-arm/arch-rpc/system.h
 *
 * Copyright (c) 1996 Russell King
 */
#ifndef __ASM_ARCH_SYSTEM_H
#define __ASM_ARCH_SYSTEM_H

#define arch_hard_reset() {						\
	extern void ecard_reset (int card);				\
	int a = 0;							\
	ecard_reset (-1);						\
	cli();								\
	flush_cache_all ();						\
	flush_tlb_all ();						\
	__asm__ __volatile__("mrc p15, 0, %0, c1, c0, 0;"		\
			     "bic %0, %0, #15;"				\
			     "bic %0, %0, #0x1300;"			\
			     "mcr p15, 0, %0, c1, c0, 0;"		\
			     "mov pc, #0"				\
			 : "=&r" (a) : "r" (a)); \
	}

#endif
