/*
 * config.h
 *
 * Sound system configuration file
 *
 */

#ifndef __sound_config_h
#define __sound_config_h

/*
 * This is the number of channels that the system has
 * *** Hardcoded in soundirq.s
 */
#define N_CHANNELS	8

/*
 * This is the default number of channels initially scanned
 */
#define SOUND_DEFAULTLGCHANNELS	0

/*
 * This is the default buffer length.  MUST be a multiple of 16
 */
#define SOUND_DEFAULTLENGTH	208

/*
 * This is the default period between samples output between channels (72)
 */
#define SOUND_DEFAULTPERIOD	72

/*
 * This is the output buffer size.
 * *** Hardcoded in soundvars.s
 */
#define SOUND_SNDBUFSIZE	0x1000

/*
 * Max number of /dev devices
 */
#define MAX_OPS 20

#endif
